<?php

namespace ByDedi\AdminBundle\Entity\Traits;

use Doctrine\ORM\Mapping as ORM;
use Knp\DoctrineBehaviors\Model as ORMBehaviors;
use Symfony\Component\PropertyAccess\PropertyAccess;

trait Translatable
{
    public function __call($method, $arguments)
    {
        return PropertyAccess::createPropertyAccessor()->getValue($this->translate(), $method);
    }

    /**
     * @param $method
     * @param $arguments
     * @return mixed
     */
    /*public function __call($method, $arguments)
    {
        if (
            !is_callable([$this->translate($this->getCurrentLocale()), $method])
            && strpos($method, 'get') === false
            && strpos($method, 'set') === false
        ) {
            $method = 'get' . ucfirst($method);
        }
        $value = null;
        if (strpos($method, 'get') !== false) {
            try {
                $value = PropertyAccess::createPropertyAccessor()->getValue($this->translate($this->getCurrentLocale()), $method);
            } catch (\Exception $e) {
            }
        }
        if ($value == null) {
            try {
                $value = $this->proxyCurrentLocaleTranslation($method, $arguments);
            } catch (\Exception $e) {
            }
        }
        return $value;
    }*/

    /**
     * @param $property
     * @param $value
     */
    /*public function __set($property, $value)
    {
        $method = 'set'.ucfirst($property);
        if (!property_exists($this, $property)) {
            $this->proxyCurrentLocaleTranslation($method, [$value]);
        } else {
            if (method_exists($this, $method)) {
                $this->$method($value);
            } else {
                $this->$property = $value;
            }
        }
    }*/

    /**
     * @param $property
     * @return mixed
     */
    /* public function __get($property)
    {
        $method = 'get'.ucfirst($property);
        if (!property_exists($this, $property)) {
            return PropertyAccess::createPropertyAccessor()->getValue($this->translate($this->getCurrentLocale()), $method);
        } else {
            if (method_exists($this, $method)) {
                return $this->$method;
            }
        }
    }*/
}
